---
# CHECK REQUIREMENTS
# ==================

# -- required vars
- name  : '{{ role_namespace }}.check.required.vars'
  assert:
    that:
      - (vars[item] is defined)
    msg: 'VARIABLE [{{ item }}] has to be defined for this host'
  with_items: '{{ role_required_vars }}'


# -- supported systems
- name  : '{{ role_namespace }}.check.supported.os'
  assert:
    that:
      - (sys_os_family in role_supported_os)
    msg: 'OS [{{ sys_os_family }}] is not supported by this role (yet)'


# -- supported filesystems
- name  : '{{ role_namespace }}.check.supported.fs'
  assert:
    that:
      - (THIS_VOLUME.vol_mnt_type in role_supported_fs)
    msg: 'FS [{{ THIS_VOLUME.vol_mnt_type }}] is not supported by this role (yet)'
  with_items: '{{ sys_volumes }}'
  loop_control:
    loop_var: 'THIS_VOLUME'
    label: '{{ THIS_VOLUME.vol_mnt_type }} ({{ THIS_VOLUME.name }})'


# debug sys type
- name: '{{ role_namespace }}.debug.sys.type'
  debug:
    msg: '{{ run_mode|upper }} {{ role_shortname }} PROFILE on [{{ sys_os_family }}] system'


# load var file according to sys_os_family
- name: '{{ role_namespace }}.load.{{ sys_os_family }}.vars'
  include_vars: '{{ sys_os_family }}.yml'


# use legacy ansible_python_interpreter for RHEL7 hosts
- name: '{{ role_namespace }}.use.legacy.ansible_python_interpreter'
  set_fact:
    ansible_python_interpreter: '/usr/bin/python'
  when:
    - (sys_os_family in ["redhat"])
    - (ansible_distribution_major_version|int < 8)


# load FS deploy/remove tasks according to run_mode
- name: '{{ role_namespace }}.load.vol.{{ run_mode }}.tasks'
  include_tasks: 'vol.{{ run_mode }}.yml'
  with_items: '{{ sys_volumes }}'
  loop_control:
    loop_var: 'THIS_VOLUME'
    label: '{{ run_mode|upper }} {{ THIS_VOLUME.name }} ({{ THIS_VOLUME.vol_mnt_type }})'
  when:
    - (run_mode in ["deploy","remove"])
    - (THIS_VOLUME.dst_hosts is not defined) or (inventory_hostname in THIS_VOLUME.dst_hosts)


# eof
